(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: SAKS.PAS                                                       *)
(*  Obsah: program pro skladani a automaticke upravy textovych souboru     *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 28.5.2014                                             *)
(*  Pro kompilaci: RETEZCE.TPU, LFN.TPU, NFSUP.TPU, (DOS, STRINGS)         *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program skladac_a_konvertor_souboru;
{Navod k pouziti je v souboru SAKS.TXT.}
{$I-,X+}
uses dos,strings,retezce,lfn,nfsup;

const maxsymbolu=30; {max. pocet symbolu a promennych (kazdeho zvlast) v jedne zavorce}
      maxdelkas=30; {max. delka jmena symbolu nebo promenne}
      velbaf=4096; {velikost kopirovaciho bufferu - velikost muze byt libovolna az do 64 KB}
      hranice=velbaf-300; {urcuje okamzik, kdy uz se ma bafr vyklopit do souboru}
label KonecVstupu, {no jo, no jo... ale zkuste se nekdy dostat z nekolika
                    mist nekolika vnorenych cyklu do stejneho bodu, bez
                    zasekani programu hromadami podminek :-]}
      SmazCarku; {Tohle mi setri duplikaci pulky hlavniho cyklu. Asi by to slo
                  nahradit prepsanim celeho programu do funkci, ale na to uz
                  jsem moc liny.}
var JmenoSkriptu:pathstr;
    skript, {soubor s ridicim skriptem}
    log:text; {soubor pro vypisy}

    prikaz:string; {pro nacitani radku ze skriptu (zpracovane useky se z nej postupne mazou)}
    kurzor:byte; {pro pohyb v prikazu a polich}
    oddelovace:set of char; {pro pohodlnejsi porovnavani nekolika znaku najednou}
    pokracujeme:boolean; {pomocny priznak pro nastavovani viceradkovych prikazu}

    vstup,vystup:file; {vstupni a vystupni datovy soubor}
    JmenoVystupu,JmenoVstupu:string; {kratka dosovska jmena}
    DlouheJmenoVstupu,DlouheJmenoVystupu:pchar; {dlouha windowsovska jmena}

    bafr:array[1..velbaf] of char; {vystupni buffer (aby se nemuselo zapisovat znak po znaku)}
    nacteno,zapsano:word; {pocitadla nactenych a zapsanych znaku}

    mezipamet:array[1..velbaf] of char; {vstupni buffer (aby se nemuselo cist znak po znaku)}
    VMezipameti,CteciKurzor:word; {pocet bytu v mezipameti a index, odkud se z ni ma cist}

    symboly:array[1..maxsymbolu] of string[maxdelkas]; {seznam symbolu definovanych pro tenhle vstupni soubor...}
    pocetsymbolu:byte; {...a kolik jich v tom seznamu je}
    symbol:string[maxdelkas]; {symbol, na ktery se prave narazilo uvnitr souboru}
    pritomen:boolean; {jestli ten symbol je v seznamu nebo ne}
    promenne:array[1..maxsymbolu] of record {seznam pro parametry typu jmeno=hodnota}
                                     jmeno:string[maxdelkas];
                                     hodnota:string[255-4]; {nejvic, co se da narvat na jeden radek}
                                     end;
    pocetpromennych:byte;
    jetopromenna:boolean; {pomocny priznak pro identifikaci typu parametru}
    prechroustat:boolean; {signalizace pritomnosti zavorky za jmenem, neboli je treba prechroustat soubor konvertorem}

    znak:char; {pomocna}
    bafrnadlouhajmena:array[0..2*256-1] of char; {misto na dva stringy - kvuli tem pcharum}
    fungujeLFN, {jestli funguje podpora dlouhych jmen}
    dlouhe:boolean; {pomocna pro pamatovani, jestli je nejake jmeno souboru dlouhe nebo ne}
    kod:word; {pro navratove kody a podobne}
    BylaChyba:boolean; {pro pamatovani, jestli doslo k chybam, ktere by stalo za to nahlasit}
    inverze:boolean; {true: vyhodnocuji se jenom radky zacinajici na '[', false: tyhle radky se zahazuji jako komentare}


procedure VyklopTo; {zapise data z bafru do vystupniho souboru}
Begin
if nacteno<>0 then begin
                   blockwrite(vystup,bafr,nacteno);
                   if ioresult<>0 then begin
                                       writeln('** Do souboru ',jmenovystupu,' uz se neda zapisovat.');
                                       bylachyba:=true;
                                       end;
                   nacteno:=0;
                   end;
End;{vyklopto}

procedure loguj(zprava:string);
Begin
writeln(log,zprava);
if ioresult<>0 then {nevsimej si toho};
End;{loguj}

procedure CekejNaEnter;
Begin
writeln;
write('*** Zmackni Enter...');
readln;
End;{cekejnaenter}

function CtiZnak(var kam:char):boolean; {nacita jeden znak ze vstupniho souboru (pro urychleni to bere pres mezipamet)}
var vpohode:boolean;                    {pri uspechu vraci true}
Begin
if vmezipameti=0 then begin
                      blockread(vstup,mezipamet[1],velbaf,vmezipameti);
                      vpohode:=(ioresult=0)and(vmezipameti<>0);
                      ctecikurzor:=1;
                      end
                 else vpohode:=true;
kam:=mezipamet[ctecikurzor];
inc(ctecikurzor);
dec(vmezipameti);
ctiznak:=vpohode;
End;{ctiznak}

BEGIN
writeln;
writeln('---------------- Skladac a konvertor souboru ----------------');
writeln('                     (cc) Mircosoft 2014');
writeln;
dlouhejmenovstupu:=@bafrnadlouhajmena[0];
dlouhejmenovystupu:=@bafrnadlouhajmena[256];
bylachyba:=false;
inverze:=false;

{kontrola funkce LFN (nekolik promennych ted zneuziju na pomocne buffery):}
getdir(0,jmenovstupu); {aktualni adresar na tomhle disku}
jmenovstupu[4]:=#0; {orizni na tri znaky (napr. 'C:\')}
fungujelfn:=(lfilesysteminfo(@jmenovstupu[1],@jmenovystupu[1],255,kod,nacteno,zapsano)=0)
            and(jmenovystupu[1]<>#0)and(kod and $4000<>0);
                  {^jmeno systemu souboru        ^LFN podporovano}
if not fungujelfn then begin
                       writeln('Pozor, system nepodporuje dlouha jmena souboru.');
                       writeln('Jestli ridici skript takova jmena obsahuje, budou spatne pochopena.');
                       writeln('Jestli ne, vsechno je v poradku.');
                       writeln;
                       end;

{zjisteni jmena a otevreni skriptu:}
if paramcount=0 then begin
                     writeln('Ridici prikazy se programu predavaji v textovem souboru, ktery se uvede');
                     writeln('jako parametr. Podrobny navod je v souboru SAKS.TXT.');
                     cekejnaenter;
                     halt;
                     end;
assign(skript,paramstr(1)); {LFN ted neni potreba resit, do parametru system preda zkracene a stejne ten soubor jenom cteme}
reset(skript);
if ioresult<>0 then begin
                    writeln('** Nepovedlo se otevrit skript ',paramstr(1),'.');
                    cekejnaenter;
                    halt;
                    end;
write('Zpracovavam skript ',paramstr(1));

assign(log,'SAKS.LOG');
rewrite(log);
if ioresult=0 then begin
                   writeln(log,'Skript: ',paramstr(1));
                   writeln(log);
                   if ioresult<>0 then {je mi to jedno};
                   end;

{cyklus pro jednotlive prikazy skriptu:}
while not eof(skript) do
 begin
 {nacteni prikazu a vyfiltrovani pripadnych komentaru a prazdnych radku:}
 readln(skript,prikaz);
 prikaz:=strip(prikaz,'o',' ');
 if stringup(prikaz)='[INV]' then begin {zacina nebo konci invertovany usek}
                                  inverze:=not inverze;
                                  continue;
                                  end;
 if prikaz[1]='[' then if inverze then begin {zpracuj, je to prikaz}
                                       delete(prikaz,1,1);
                                       prikaz:=strip(prikaz,'l',' ');
                                       end
                                  else continue {zahod, je to komentar}
                  else if inverze then continue; {v inverznim rezimu zahazuj vsechno krome [tohohle}
 if (prikaz='')or(prikaz[1]=';') then continue; {prazdne radky a komentare zahod}
 if prikaz[1]='{' then begin {zacatek viceradkoveho zakomentovaneho useku - zahod ho cely}
                       if eof(skript) then break; {aby se necetlo zpoza konce souboru}
                        repeat
                        readln(skript,prikaz);
                        prikaz:=strip(prikaz,'o',' ');
                        until (prikaz[1]='}') or eof(skript);
                       if prikaz[1]<>'}' then break; {eof a porad jsme v komentari - je hotovo}
                       if prikaz='}' then continue {na radku byla jenom ta zavorka}
                                     else begin {za zavorkou je jeste neco}
                                          delete(prikaz,1,1); {zavorku pryc}
                                          prikaz:=strip(prikaz,'l',' '); {mezery za ni taky}
                                          end;
                       end;
 loguj(prikaz);

 {nalezeni jmena vystupniho souboru:}
 if prikaz[1]='"' then begin {jmeno v uvozovkach - konec hledame podle druhe uvozovky}
                       delete(prikaz,1,1); {uvodni uvozovku smaz}
                       znak:='"';
                       end
                  else znak:='=';
 kurzor:=pos(znak,prikaz);
 if kurzor=0 then begin
                  loguj('** Neplatny prikaz, preskakuji.');
                  bylachyba:=true;
                  continue;
                  end;
 jmenovystupu:=strip(left(prikaz,kurzor-1),'o',' ');
 delete(prikaz,1,kurzor); {smaz jmeno i s koncovou uvozovkou nebo rovnasem}
 if znak='"' then begin {jestli bylo jmeno v uvozovkach, musime jeste najit rovnase}
                  kurzor:=pos('=',prikaz);
                  if kurzor=0 then begin
                                   loguj('** Neplatny prikaz, preskakuji.');
                                   bylachyba:=true;
                                   continue;
                                   end;
                  delete(prikaz,1,kurzor); {smazani rovnase}
                  end;
 prikaz:=strip(prikaz,'l',' '); {smazani pripadnych mezer za rovnasem}
 kurzor:=1;
 if fungujelfn then begin {muzeme pouzit dlouhe jmeno}
                    strpcopy(dlouhejmenovystupu,jmenovystupu);
                    jmenovystupu:='VYSTUP.$$$';
                    {i kdyby jmeno ve skutecnosti dlouhe nebylo, je lepsi
                    LFN pouzit, protoze zachovava velikost pismen presne jak
                    byla uvedena ve skriptu}
                    end
               else dlouhejmenovystupu:=''; {nezbyva nez pouzit kratke jmeno}
 assign(vystup,jmenovystupu);
 rewrite(vystup,1);
 if ioresult<>0 then begin
                     loguj('** Nelze otevrit vystupni soubor '+jmenovystupu+', preskakuji prikaz.');
                     bylachyba:=true;
                     continue;
                     end;
 {vystup je pripraveny k zapisu}
 {na zacatku prikazu je ted jmeno prvniho vstupniho souboru}

 {cyklus pro vstupni soubory:}
 while prikaz<>'' do
  begin
  {primo zadany text:}
  if prikaz[1]='%'
    then begin
         kurzor:=2; {prvni znak textu za uvodnim %}
         while (kurzor<=length(prikaz))and(prikaz[kurzor]<>'%') do inc(kurzor);
         {ted je kurzor bud na ukoncovacim % nebo za koncem prikazu}
         if kurzor>2 then blockwrite(vystup,prikaz[2],kurzor-2);
         if ioresult<>0 then begin
                             loguj('** Do souboru '+jmenovystupu+' uz nejde zapisovat.');
                             bylachyba:=true;
                             end;
         delete(prikaz,1,kurzor); {smaz zapsany text vcetne oddelovacu}
         prikaz:=strip(prikaz,'l',' '); {pripadne mezery pred carkou}
         {ted jsme na carce za textem}
         end
    else begin
         {do tohohle else patri cely tenhle usek pro soubory: (uz jsem liny to cele odsazovat :-])}
  {zadane jmeno souboru:}
  oddelovace:=[' ',',','('];
  dlouhe:=prikaz[1]='"';
  if dlouhe then begin
                 delete(prikaz,1,1); {smazani pripadne uvodni uvozovky}
                 include(oddelovace,'"');
                 end;
  kurzor:=1;
  while (kurzor<=length(prikaz)) and not (prikaz[kurzor] in oddelovace) do inc(kurzor);
  {ted jsme za jmenem vstupu (na oddelovacim znaku nebo za koncem prikazu)}
  jmenovstupu:=left(prikaz,kurzor-1);
  if dlouhe then delete(prikaz,1,kurzor) {smaz jmeno i s koncovou uvozovkou}
            else delete(prikaz,1,kurzor-1); {jinak bez ni}
  prikaz:=strip(prikaz,'l',' ');
  {ted jsme bud na ( nebo na , nebo na konci prikazu}

  {vyrizeni zavorky s parametry, pokud tam je:}
  pocetsymbolu:=0;
  pocetpromennych:=0;
  if prikaz[1]='(' then begin {mame tady zavorku se symboly, tak je uloz}
                        prechroustat:=true;
                         repeat
                         delete(prikaz,1,1); {umazani uvodni zavorky nebo carky za minulym symbolem}
                         prikaz:=strip(prikaz,'l',' '); {umazani pripadnych mezer pred zacatkem symbolu}
                         {ted na zacatku prikazu zacina symbol}
                         kurzor:=1;
                         while (kurzor<=length(prikaz))and not(prikaz[kurzor] in [' ',',',')','=']) do inc(kurzor);
                         {ted jsme za koncem symbolu - na ) nebo za koncem prikazu}
                         if kurzor>1
                           then begin {jestli tam neco bylo, zpracuj to}
                                symbol:=left(prikaz,kurzor-1); {jmeno je jasne}
                                delete(prikaz,1,kurzor-1); {smazani symbolu}
                                prikaz:=strip(prikaz,'l',' '); {smazani pripadnych mezer za symbolem}
                                if prikaz[1]='='
                                  then begin {promenna}
                                       inc(pocetpromennych);
                                       promenne[pocetpromennych].jmeno:=symbol;
                                       delete(prikaz,1,1);
                                       prikaz:=strip(prikaz,'l',' ');
                                       kurzor:=1;
                                       while (kurzor<=length(prikaz))and(prikaz[kurzor]<>'%') do inc(kurzor);
                                       promenne[pocetpromennych].hodnota:=left(prikaz,kurzor-1);
                                       delete(prikaz,1,kurzor); {smaz hodnotu i ukoncovaci %}
                                       prikaz:=strip(prikaz,'l',' ');
                                       end
                                  else begin {jednoduchy symbol}
                                       inc(pocetsymbolu);
                                       symboly[pocetsymbolu]:=symbol;
                                       end;
                                end;
                         {ted je na zacatku prikazu carka, zavorka nebo uz nic}
                         until (prikaz='')or(prikaz[1]=')');
                        delete(prikaz,1,1); {umazani koncove zavorky}
                        prikaz:=strip(prikaz,'l',' '); {mezery za zavorkou}
                        end
                   else prechroustat:=false;
  {ted jsme za zavorkou - bud na carce pred dalsim souborem, nebo za koncem prikazu}

  {vyrizeni pripadneho dlouheho jmena a kontrola existence souboru:}
  if fungujelfn then begin
                     strpcopy(dlouhejmenovstupu,jmenovstupu);
                     kod:=lgetshortname(dlouhejmenovstupu,@jmenovstupu[1]);
                     if kod<>0 then begin
                                    loguj('** Soubor '+strpas(dlouhejmenovstupu)+' neexistuje, preskakuji ho.');
                                    bylachyba:=true;
                                    goto smazcarku;
                                    end;
                     jmenovstupu[0]:=chr(strlen(@jmenovstupu[1]));
                     end;

  {jmeno je jasne, muzeme ten soubor otevrit:}
  assign(vstup,jmenovstupu);
  reset(vstup,1);
  if ioresult=0
    then begin
         if prechroustat
           then begin {kopirovani s upravami}
                nacteno:=0;
                vmezipameti:=0;
                while (not eof(vstup))or(vmezipameti<>0) do
                 begin
                 if not ctiznak(znak) then break;
                 if znak='('
                   then begin
                        if not ctiznak(znak) then break;
                        if znak='%'
                          then begin {je to zacatek prepinace}
                               symbol:='';
                                repeat
                                if ctiznak(znak) and not (znak in [':','%']) then symbol:=symbol+znak
                                                                             else break;
                                until false;
                               if znak='%' then begin
                                                if not ctiznak(znak) {)}
                                                  then begin
                                                       loguj('** Neocekavany konec souboru '+jmenovstupu+
                                                             '. Zkopirovalo se, co se dalo.');
                                                       bylachyba:=true;
                                                       break; {eof nebo chyba cteni, kazdopadne s timhle souborem koncime}
                                                       end;
                                                jetopromenna:=true;
                                                end
                                           else jetopromenna:=false;
                               symbol:=strip(symbol,'o',' ');
                               {symbol mame nacteny a oddelovac zahozeny}
                               {mame ten symbol v seznamu?}
                               pritomen:=false;
                               if jetopromenna
                                 then begin
                                      for kurzor:=1 to pocetpromennych do
                                       if symbol=promenne[kurzor].jmeno then begin
                                                                             pritomen:=true;
                                                                             kod:=kurzor;
                                                                             break;
                                                                             end;
                                      if pritomen
                                        then begin
                                             move32(promenne[kod].hodnota[1],bafr[nacteno+1],length(promenne[kod].hodnota));
                                             inc(nacteno,length(promenne[kod].hodnota));
                                             if nacteno>hranice then vyklopto; {misto v bafru urcite vystaci - radek je }
                                             end;                              {max. 255 znaku dlouhy a rezervu mame 300}
                                      end
                                 else begin
                                      for kurzor:=1 to pocetsymbolu do
                                       if symbol=symboly[kurzor] then pritomen:=true;
                                      {projed prvni text:}
                                       repeat
                                       if not ctiznak(znak) then goto konecvstupu;
                                       if znak='%'
                                         then begin
                                              if not ctiznak(znak) then goto konecvstupu;
                                              if znak='%' then break {byl to oddelovac, prvni text mame vyrizeny}
                                                          else if pritomen then begin {nebyl to oddelovac, zkopiruj to}
                                                                                inc(nacteno);
                                                                                bafr[nacteno]:='%';
                                                                                inc(nacteno);
                                                                                bafr[nacteno]:=znak;
                                                                                end;
                                              end
                                         else if pritomen then begin
                                                               inc(nacteno);
                                                               bafr[nacteno]:=znak;
                                                               end;
                                       if nacteno>hranice then vyklopto;
                                       until false; {cteni prvniho textu (konci se breakem)}
                                      {projed druhy text:}
                                       repeat
                                       if not ctiznak(znak) then goto konecvstupu;
                                       if znak='%'
                                         then begin
                                              if not ctiznak(znak) then goto konecvstupu;
                                              if znak=')' then break {byl to konec prepinace, mame hotovo}
                                                          else if not pritomen then begin {nebyl to konec prikazu, zkopiruj to}
                                                                                    inc(nacteno);
                                                                                    bafr[nacteno]:='%';
                                                                                    inc(nacteno);
                                                                                    bafr[nacteno]:=znak;
                                                                                    end;
                                              end
                                         else if not pritomen then begin
                                                                   inc(nacteno);
                                                                   bafr[nacteno]:=znak;
                                                                   end;
                                       if nacteno>hranice then vyklopto;
                                       until false; {cteni druheho textu (konci se breakem)}
                                      end;
                               end
                          else begin {neni to prikaz, tak to jenom zkopiruj}
                               inc(nacteno);
                               bafr[nacteno]:='(';
                               inc(nacteno);
                               bafr[nacteno]:=znak;
                               if nacteno>hranice then vyklopto;
                               end;
                        end
                   else begin {neni to zavorka, tak proste kopirujeme}
                        inc(nacteno);
                        bafr[nacteno]:=znak;
                        if nacteno>hranice then vyklopto;
                        end;
                 end;{while not eof(vstup)}
                konecvstupu:
                vyklopto;
                end{kopirovani s upravami}
           else while not eof(vstup) do begin {kopirovani bez uprav}
                                        blockread(vstup,bafr,velbaf,nacteno);
                                        blockwrite(vystup,bafr,nacteno,zapsano);
                                        if zapsano<>nacteno then begin
                                                                 loguj('** Soubor '+jmenovstupu+
                                                                         ' se nepodarilo zkopirovat cely.');
                                                                 bylachyba:=true;
                                                                 break;
                                                                 end;
                                        end;
         close(vstup);
         if ioresult<>0 then loguj(' Chyba pri zavirani souboru '+jmenovstupu+', ale asi nic vazneho.');
         end
    else begin
         loguj('** Nelze otevrit vstupni soubor '+jmenovstupu+', preskakuji ho.');
         bylachyba:=true;
         end;

         end;{byl to soubor a ne %text%}

  {posun na zacatek dalsiho vstupu, pokud tam je:}
  {ted jsme bud na konci prikazu nebo na carce pred nasledujicim vstupem}
  smazcarku:
  pokracujeme:=(prikaz<>'')and(prikaz[1]=',');
  delete(prikaz,1,1); {smaz carku za minulym vstupem}
  prikaz:=strip(prikaz,'l',' '); {smaz pripadne mezery za carkou}
  {jestli prikaz koncil carkou, znamena to, ze pokracuje na dalsim radku,
  takze si ho nacteme a pokracujeme bez preruseni dal:}
  if (prikaz='')and pokracujeme
    then begin
         while not eof(skript) do begin
                                  readln(skript,prikaz);
                                  if ioresult<>0 then begin
                                                      prikaz:='';
                                                      loguj('** Necekany konec skriptu.');
                                                      bylachyba:=true;
                                                      break;
                                                      end;
                                  prikaz:=strip(prikaz,'o',' ');
                                  if (prikaz<>'') and not (prikaz[1] in [';','[']) then break;
                                  end;
         loguj(prikaz);
         end;
  {ted jsme bud na zacatku dalsiho vstupu, nebo na konci prikazu}
  end;{while prikaz<>''}

 {prikaz je vyrizeny, zavreme vystup a jdeme na dalsi}
 close(vystup);
 if ioresult<>0 then loguj(' Chyba pri zavirani souboru '+jmenovystupu+', ale asi nic vazneho.');
 if strlen(dlouhejmenovystupu)<>0
   then begin
        lerase(dlouhejmenovystupu); {pro pripad, ze by uz existoval}
        jmenovystupu[length(jmenovystupu)+1]:=#0; {ukoncovaci nula}
        kod:=lrename(@jmenovystupu[1],dlouhejmenovystupu);
        if kod<>0 then begin
                      loguj('** Nepodarilo se prejmenovat pomocny soubor '+jmenovystupu+' na '+strpas(dlouhejmenovystupu)+'.');
                       bylachyba:=true;
                       end;
        jmenovystupu:=strpas(dlouhejmenovystupu);
        end;
 loguj(' Soubor '+jmenovystupu+' je hotovy.');
 loguj('');
 write('.');
 end;{while not eof(skript)}

close(skript);
if ioresult<>0 then loguj('Nepovedlo se zavrit skript, ale asi o nic nejde.');
if bylachyba then begin
                  loguj('');
                  loguj('Dokonceno, ale s chybami.');
                  end;
close(log);
if ioresult<>0 then {je mi to jedno};

writeln;
if bylachyba then begin
                  writeln('Chybicka se vloudila!');
                  writeln('Podrobny vypis je v souboru SAKS.LOG, chybove hlasky najdete podle znacky **.');
                  cekejnaenter;
                  end
             else begin
                  writeln('Hotovo, vse v poradku.');
                  erase(log); kod:=ioresult;
                  end;
writeln;
END.